package gs.test.v0.api

import cats.Show

/** Opaque type representing tags that may be assigned to a [[Test]].
  */
opaque type Tag = String

object Tag:

  /** Instantiate a new [[Tag]].
    *
    * @param tag
    *   The candidate string.
    * @return
    *   The new [[Tag]] instance.
    */
  def apply(tag: String): Tag = tag

  given CanEqual[Tag, Tag] = CanEqual.derived

  given Show[Tag] = tag => tag

end Tag
