package gs.test.v0.runtime.engine

sealed abstract class ConcurrencySetting(val name: String):
  def toInt(): Int

object ConcurrencySetting:

  case object Serial extends ConcurrencySetting("serial"):
    override def toInt(): Int = 1

  case class Concurrent(
    maximum: MaximumConcurrency
  ) extends ConcurrencySetting("concurrent"):
    override def toInt(): Int = maximum.toInt()

end ConcurrencySetting
