package gs.test.v0.runtime.engine

opaque type MaximumConcurrency = Int

object MaximumConcurrency:

  def apply(candidate: Int): MaximumConcurrency =
    if candidate <= 0 then
      throw new IllegalArgumentException(
        "Maximum concurrency must be 1 or greater."
      )
    else candidate

  given CanEqual[MaximumConcurrency, MaximumConcurrency] = CanEqual.derived

  extension (mc: MaximumConcurrency) def toInt(): Int = mc

end MaximumConcurrency
